/***********************************************************************************
    Copyright 2011 Bryan Johnson, Xiaoyue Guan & Charles F. Gammie

                  mthreed  version 1.0   (released Jun 2, 2011)

    This file is part of mthreed. mthreed adopts a ZEUS-like scheme to solve 
    magnetohydrodynamic equations of motion in a shearing sheet. It uses obital 
    advection to ensure fast and accurate integration in a large shearing box. 
    

    You are morally obligated to cite the following paper in his/her
    scientific literature that results from use of any part of mthreed:

    [1] Johnson, B.M., Guan, X. \& Gammie, C.F. \ 2008, Astrophysical Journal, 
        Supplement, 177, 373


    The latest version of the mthreed is available on our code distribution
    website:
    http://rainman.astro.uiuc.edu/codelib/

    mthreed is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    mthreed is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with mthreed; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

***********************************************************************************/

REAL rhoas[NX+5][NY+5][NZ+5] ;
REAL vxas[NX+5][NY+5][NZ+5] ;
REAL vyas[NX+5][NY+5][NZ+5] ;
REAL vzas[NX+5][NY+5][NZ+5] ;
REAL pxas[NX+5][NY+5][NZ+5] ;
REAL pyas[NX+5][NY+5][NZ+5] ;
REAL pzas[NX+5][NY+5][NZ+5] ;


REAL bxas[NX+5][NY+5][NZ+5] ;
REAL byas[NX+5][NY+5][NZ+5] ;
REAL bzas[NX+5][NY+5][NZ+5] ;
REAL eas[NX+5][NY+5][NZ+5] ;

REAL work1as[NX+4][NY+4][NZ+4] ;
REAL work2as[NX+4][NY+4][NZ+4] ;
REAL work3as[NX+4][NY+4][NZ+4] ;

REAL (*rho)[NY+5][NZ+5] ;
REAL (*vx)[NY+5][NZ+5] ;
REAL (*vy)[NY+5][NZ+5] ;
REAL (*vz)[NY+5][NZ+5] ;
REAL (*px)[NY+5][NZ+5] ;
REAL (*py)[NY+5][NZ+5] ;
REAL (*pz)[NY+5][NZ+5] ;



REAL (*bx)[NY+5][NZ+5] ;
REAL (*by)[NY+5][NZ+5] ;
REAL (*bz)[NY+5][NZ+5] ;
REAL (*e)[NY+5][NZ+5] ;
REAL (*work1)[NY+4][NZ+4] ;
REAL (*work2)[NY+4][NZ+4] ;
REAL (*work3)[NY+4][NZ+4] ;

REAL cour ;
REAL cs ;
REAL c ;
REAL gam ;
REAL dx,dy,dz ;
REAL dt ;
REAL t,tf ;
REAL nu_vnr ;
REAL nu_l ;

REAL Lx ;
REAL Ly ;
REAL Lz ;

REAL dV ;

REAL DTd ;
REAL DTi ;
REAL DTl ;

REAL drive ;
REAL A0,B0,B0x,B0y,B0z ;
REAL va, vax, vay, vaz, vs, vadk, kappa2;
REAL work,workp ;
REAL W,Wz,q ;

REAL kx,ky,kz ;
REAL k0, k20, dkxdt;
REAL remr[8],remi[8],norm,pert ;
REAL F10,F20,F30,F40,dF1dt0,dF2dt0,d2F1dt20,d2F2dt20 ;

int nstep ;

